import * as cdk from '@aws-cdk/core';
/**
 * Aspect that makes IMDSv2 required on instances deployed by AutoScalingGroups.
 *
 * @stability stable
 */
export declare class AutoScalingGroupRequireImdsv2Aspect implements cdk.IAspect {
    /**
     * @stability stable
     */
    constructor();
    /**
     * All aspects can visit an IConstruct.
     *
     * @stability stable
     */
    visit(node: cdk.IConstruct): void;
    /**
     * Adds a warning annotation to a node.
     *
     * @param node The scope to add the warning to.
     * @param message The warning message.
     * @stability stable
     */
    protected warn(node: cdk.IConstruct, message: string): void;
}
