import { ILifecycleHook } from './lifecycle-hook';
import { Construct } from '@aws-cdk/core';
/**
 * Interface for autoscaling lifecycle hook targets.
 *
 * @stability stable
 */
export interface ILifecycleHookTarget {
    /**
     * Called when this object is used as the target of a lifecycle hook.
     *
     * @stability stable
     */
    bind(scope: Construct, lifecycleHook: ILifecycleHook): LifecycleHookTargetConfig;
}
/**
 * Properties to add the target to a lifecycle hook.
 *
 * @stability stable
 */
export interface LifecycleHookTargetConfig {
    /**
     * The ARN to use as the notification target.
     *
     * @stability stable
     */
    readonly notificationTargetArn: string;
}
